namespace PkmnLib.Plugin.Gen7.Scripts.Abilities;

/// <summary>
/// Pickpocket is an ability that steals an item from a Pokémon that makes contact.
///
/// <see href="https://bulbapedia.bulbagarden.net/wiki/Pickpocket_(Ability)">Bulbapedia - Pickpocket</see>
/// </summary>
[Script(ScriptCategory.Ability, "pickpocket")]
public class Pickpocket : Script, IScriptOnIncomingHit
{
    /// <inheritdoc />
    public void OnIncomingHit(IExecutingMove move, IPokemon target, byte hit)
    {
        if (!move.GetHitData(target, hit).IsContact || target.HeldItem is not null ||
            !move.User.TryStealHeldItem(out var item))
            return;
        move.Battle.EventHook.Invoke(new AbilityTriggerEvent(target));
        _ = target.ForceSetHeldItem(item);
    }
}